
'#--- Print results To the file "imageXX+txt" ----------------

'#@Image = ("MCM 3D Image", "1 pc 0 tc", "c 192 192 192", @points, @triangles)
@Image = (@points, @Lines, @triangles)

Open (Out,"> ++/mcm/design/image"+icount+"+txt")
Print Out "title\n"
Print Out "13 pc lc tc\n"
Print Out "c "+ic0+"\n"
Print Out "c "+ic1+"\n"
Print Out "c "+ic2+"\n"
Print Out "c "+ic3+"\n"
Print Out "c "+ic4+"\n"
Print Out "c "+ic5+"\n"
Print Out "c "+ic6+"\n"
Print Out "c "+ic7+"\n"
Print Out "c "+ic8+"\n"
Print Out "c "+ic9+"\n"
Print Out "c "+ic10+"\n"
Print Out "c "+ic11+"\n"
Print Out "c "+ic12+"\n"
For x (@Image) {
   Print Out x+"\n"
}
Close Out

If (measure) { timerresult18 = tv_interval ( t0 )}

'#------- Formatting ---------------

px = sprintf("%+3f",px)
py = sprintf("%+3f",py)
thickness = sprintf("%+3f",thickness)
power = sprintf("%+2f",power)
trueleads = sprintf("%+0f",trueleads)

weight = sprintf("%+2f",weight)
weightparts = sprintf("%+2f",weightparts)
weightpackage = sprintf("%+2f",weightpackage)
weightsubstrate = sprintf("%+2f",weightsubstrate)
weightlid = sprintf("%+2f",weightlid)
weightsealring = sprintf("%+2f",weightsealring)
weightleads = sprintf("%+2f",weightleads)
weightballs = sprintf("%+2f",weightballs)
weightledge = sprintf("%+2f",weightledge)
weightint = sprintf("%+2f",weightint)

Tmax = sprintf("%+2f",Tmax)
Tpart = sprintf("%+2f",Tpart)
Tpatt = sprintf("%+2f",Tpatt)
Tint = sprintf("%+2f",Tint)
Tsub = sprintf("%+2f",Tsub)
Tsatt = sprintf("%+2f",Tsatt)
Tpkg = sprintf("%+2f",Tpkg)
Tkatt = sprintf("%+2f",Tkatt)

'#------- Write the imageXX+htm file ----------------------

screen = res"}
elapsedtime = time - starttime +1

Open (Out,"> ++/mcm/design/image"+icount+"+htm")

Print Out <<stop_html

<html>
<head>
<title>3D Image</title>
</head>
<body>
<center>
<img Width=640 height=24 Border=0 src="++/++/images/garybeenes+gif">
<img Width=640 height=60 Border=0 src="++/++/images/mcmdesign1+gif">
</center>
<p><table>
<tr>
<td nowrap valign=top>

stop_html

j=1
If (mult"}) {
  j=4
  screen = screen/2
  If (screen < 310) { screen = 310 }
}

For  (i=0 i<j i=i+1) {
  Print Out <<multiple_applet
  <applet Code=tov+Class archive="tov+jar" Width=screen height=screen>
  <param Name=regcode value=82481266383754>
  <param Name=tovdata value="imageicount+txt">
  <param Name=spin value="animate">
  <param Name=Display value="render">
  <param Name=anglestep value="3">
  <param Name=Scale value="0+7">
  <param Name=mainbg value="0 192 192">
  <param Name=mainfg value="0 0 0">
  <param Name=butbg value="60 192 255">
  <param Name=butfg value="0 0 0">
  <param Name=bgcolor value="ibackground">
  <param Name=delay value=50>
  </applet>
multiple_applet
  If (i==1) { Print Out "<br>" }
}

Print Out <<stop_html9

<td valign=top>
<table cellspacing=0 cellpadding=0>
<tr><td nowrap><img Width=14 height=14 src="/images/ballblue+gif">
    &nbsp<b>Size (In+)</b>
        <tr><td>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp Length<td align=Right>py
        <tr><td>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp Width<td align=Right>px
        <tr><td>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp Thickness<td align=Right>thickness
        <tr><td nowrap>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp I/O Count<td nowrap align=Right>trueleads
        <tr><td><td nowrap align=Right>leadmsg2
        <tr><td>&nbsp
        <tr><td nowrap colspan=4>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp leadmsg

<tr><td>&nbsp
<tr><td nowrap><img Width=14 height=14 src="/images/ballblue+gif">
&nbsp<b>Weight (gms)</b><td nowrap align=Right>weight

<tr><td>&nbsp
<tr><td nowrap><img Width=14 height=14 src="/images/ballblue+gif">
&nbsp<b>Power (W)</b><td nowrap align=Right>power

<tr><td>&nbsp
<tr><td nowrap><img Width=14 height=14 src="/images/ballblue+gif">
&nbsp<b>Temp Rise (C)</b>&nbsp<td align=Right>Tmax

stop_html9

If (showstl) {
Print Out '<tr><td>&nbsp'
Print Out '<tr><td nowrap><img width=14 height=14 src="/images/ballblue+gif">'
Print Out '&nbsp<a href="image'+icount+'+stl"><b>Binary STL File</b></a>'
}

Print Out <<stop_html8

<tr><td>&nbsp
<tr><td nowrap><img Width=14 height=14 src="/images/ballblue+gif">
&nbsp<b>Components</b><td align=Right>partcount

stop_html8

If ( imem"} > 0 ) { Print Out "<tr><td nowrap>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp
In{'nam1'}<td align=right>in{'imem'}" }

If ( ires"} > 0 ) { Print Out "<tr><td nowrap>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp
In{'nam2'}<td align=right>in{'ires'}" }

If ( iproc"} > 0 ) { Print Out "<tr><td nowrap>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp
In{'nam3'}<td align=right>in{'iproc'}" }

If ( icl"} > 0 ) { Print Out "<tr><td nowrap>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp
In{'nam4'}<td align=right>in{'icl'}" }

If ( ia"} > 0 ) { Print Out "<tr><td nowrap>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp
In{'nam5'}<td align=right>in{'ia'}" }

If ( imc"} > 0 ) { Print Out "<tr><td nowrap>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp
In{'nam6'}<td align=right>in{'imc'}" }

If ( ic"} > 0 ) { Print Out "<tr><td nowrap>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp
In{'nam7'}<td align=right>in{'ic'}" }

If ( ioth"} > 0 ) { Print Out "<tr><td nowrap>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp
In{'nam8'}<td align=right>in{'ioth'}" }

Print Out <<stop_html2

</table>

</table>

<table>
<tr><td><h3>Notes:</h3>
<tr><td nowrap><img Width=14 height=14 src="/images/ballblue+gif"> <b>Thermal Analysis</b><br>
    <ul><table>
        <tr><td valign=top nowrap colspan=2><b>Maximum Temperature Rise (C)</b>&nbsp&nbsp&nbsp<td><b>Tmax</b>
            <td>&nbsp&nbsp
            <td valign=top rowspan=8>This Is a worst Case thermal analysis+ It assumes that All
                heat Flow Is To the bottom Of the MCM without heat spreading+ It does Not
                take into account the uneven distribution Of power dissipation that may result
                In digital ICs At the driver circuits lcoated At the edge Of the die+ In some
                ICs, As much As 30% Of the device power dissipation may be located In a narrow
                band around the perimeter Of the die+ Even though an MCM's low parasitics help
                reduce this effect, a more detailed thermal analysis may be appropriate+<p>
                The thermal analysis correctly takes into account the die And substrate attachment
                materials, but those layers are Not included In the graphics generation+
        <tr><td>Part<td nowrap>Tname<td align=Right>Tpart
        <tr><td nowrap>Part Attach<td nowrap>n1<td align=Right>Tpatt
        <tr><td>Interconnect<td nowrap>n2<td align=Right>Tint

stop_html2

If (Icon"} ne "integrated") {
   Print Out "<tr><td>Substrate<td nowrap>n3<td align=right>Tsub"
   Print Out "<tr><td nowrap>Substrate attach<td nowrap>n4<td align=right>Tsatt"
}


Print Out <<stop_html3

        <tr><td>Package<td nowrap>n5<td align=Right>Tpkg
        <tr><td nowrap>Package Attach<td nowrap>n6<td align=Right>Tpatt
    </table></ul>

<tr><td nowrap><img Width=14 height=14 src="/images/ballblue+gif">
    <b>Weight Analysis</b><br>
    <ul><table>
        <tr><td nowrap><b>Total Weight (gms)&nbsp&nbsp</b><td nowrap valign=top><b>weight</b>
          <td>&nbsp&nbsp
          <td valign=top rowspan=10>The package weight includes All sections Of the MCM structure, including I/O (leads And
              solder balls) except For the perimeter pads which are assumed To be integral To the
              package+  The Online MCM Design Page provides a "thickness" For the pads Only To
              enhance the visual Image+

stop_html3

If (weightparts > 0)     { Print Out "<tr><td>Parts<td align=right>weightparts"}
If (weightlid > 0)       { Print Out "<tr><td>Lid<td align=right>weightlid"}
If (weightpackage > 0)   { Print Out "<tr><td>Package<td align=right>weightpackage"}
If (weightint > 0)       { Print Out "<tr><td>Interconnect<td align=right>weightint"}
If (weightsubstrate > 0) { Print Out "<tr><td>Substrate<td align=right>weightsubstrate"}
If (weightsealring > 0)  { Print Out "<tr><td nowrap>Seal Ring<td align=right>weightsealring"}
If (weightledge > 0 )    { Print Out "<tr><td>Ledge<td align=right>weightledge"}
If (weightleads > 0 )    { Print Out "<tr><td>Leads<td align=right>weightleads"}
If (weightballs > 0 )    { Print Out "<tr><td nowrap>Solder balls<td align=right>weightballs"}

Print Out <<stop_html4

    </table></ul>
<tr><td><img Width=14 height=14 src="/images/ballblue+gif"> <b>Size:</b><br>
   <ul>The overall body Size Of an MCM Is defined by the larger Of space needed To place
       the components, Or the space needed To accomodate the total I/O coming Off the MCM+
       A message Is provided below the Size table above To indicate which Of the factors
       was used To determine the Size Of the package+  In either Case, the body Size given does Not
       include the length Of the leads, which will affect the footprint Of the MCM On the
       Next level Of assembly+ Typically, packages are purchased With relatively Long leads
       which are cut To the preferred Size For Next-level assembly, Then formed into a specific
       shape (typically a simple bend In the lead) To support solder attachment+
    <p>
       If the package body Size As driven by I/O Is larger than the body Size As driven by
       the Parts, you have several options To Help reduce the Size:
     <ul>
     <li>Use the larger body Size despite the inefficient use Of space
     <li>User a smaller I/O pitch, but Check With your manufacturing organization
         To determine the smallest pitch which they can support during assembly+
     <li>Change From a perimeter Or leaded construction To a BGA package Style+
         Again, Check With your manufacturing organization To make sure your
         proposed package Style Is compatible With their assembly Process+
         Solder joints On BGA package sizes In excess Of 1" are susceptible to
         thermal cycling problems, so be sure To analyze your design's compatibility
         With the intended environment+
     </ul>
     <p>
     In an MCM, the die And substrate are attached With adhesive materials+  The graphics
     And calculations On this Page Do Not utilize the attachment materials, except
     In the Case Of the thermal analysis, where the attacment materials are taken into account+
     <p>
     When a BGA graphics Is selected, the thickness Of the solder balls Is used To
     calculate the overall thickness Of the MCM+  In practice, however, the solder balls
     may collapse significantly, lowering the overall thickness Of the MCM+
   </ul>

<tr><td><img Width=14 height=14 src="/images/ballblue+gif"> <b>Graphics:</b><br>
    <ul>
    This Image Is made Of pc points, lc Lines, And tc triangles+<br>
    The program took less than elapsedtime seconds To run+<br>
    This Is Image number icount generated From the Online MCM Design Center script, Version 7+0

stop_html4

If (measure) { timerresult19 = tv_interval ( t0 )}

'#---  STL subroutines ----

Sub planexy {
  xx1=ptx(_(0))  xx2=ptx(_(2))  yy1=pty(_(0))  yy2=pty(_(2))
  For (i=0 i<@xpoints i++) {
    If    (xpoints(i) > xx2) { last }
    elsif (xpoints(i) == xx1) { tempx2 = xpoints(i) }
    elsif (xpoints(i) > xx1 && xpoints(i) <= xx2) {
      tempx1 = tempx2 tempx2 = xpoints(i)
      For (j=0 j<@ypoints j++) {
        If    (ypoints(j) > yy2) { last }
        elsif (ypoints(j) == yy1) { tempy2 = ypoints(j) }
        elsif (ypoints(j) > yy1 && ypoints(j) <= yy2) {
          tempy1 = tempy2 tempy2 = ypoints(j)
          showtriangle=1
          If (testtriangle){
            For part (@allparts) {  '#does triangle fall under a part?
             (l, w, t, k, yc, xc, ptype) = split(/::/,part)
             Left = sprintf("%+3f",xc-w/2+packagekeepout)
             Right = sprintf("%+3f",xc+w/2+packagekeepout)
             top = sprintf("%+3f",yc+l/2+packagekeepout)
             bottom = sprintf("%+3f",yc-l/2+packagekeepout)
             xtest = sprintf("%+3f",(tempx2 + tempx1) / 2)
             ytest = sprintf("%+3f",(tempy2 + tempy1) / 2)
             If (xtest > Left && xtest < Right && ytest > bottom && ytest < top) {showtriangle=0last}
            }
          }
          If (showtriangle){
            push @Binary, 0,0,sign+"1"
            push @Binary, tempx1, tempy1, ptz(_(0))
            If (sign eq "") {
              push @Binary, tempx2, tempy1, ptz(_(0))
            }
            push @Binary, tempx1, tempy2, ptz(_(0))
            If (sign eq "-") {
              push @Binary, tempx2, tempy1, ptz(_(0))
            }
            push @Binary, 0
            push @Binary, 0,0,sign+"1"
            push @Binary, tempx2, tempy1, ptz(_(0))
            If (sign eq "") {
              push @Binary, tempx2, tempy2, ptz(_(0))
            }
            push @Binary, tempx1, tempy2, ptz(_(0))
            If (sign eq "-") {
              push @Binary, tempx2, tempy2, ptz(_(0))
            }
            push @Binary, 0
            polygons += 2
          }
        }
      }
    }
  }
}

Sub planexz {
  xx1=ptx(_(0))  xx2=ptx(_(2))  zz1=ptz(_(0))  zz2=ptz(_(2))
  For (i=0 i<@xpoints i++) {
    If    (xpoints(i) > xx2) { last }
    elsif (xpoints(i) == xx1) { tempx2 = xpoints(i) }
    elsif (xpoints(i) > xx1 && xpoints(i) <= xx2) {
      tempx1 = tempx2 tempx2 = xpoints(i)
      For (j=0 j<@zpoints j++) {
        If    (zpoints(j) > zz2) { last }
        elsif (zpoints(j) == zz1) { tempz2 = zpoints(j) }
        elsif (zpoints(j) > zz1 && zpoints(j) <= zz2) {
          tempz1 = tempz2 tempz2 = zpoints(j)
          push @Binary, 0,sign+"1",0
          push @Binary, tempx1, pty(_(0)), tempz1
          If (sign eq "-") {
            push @Binary, tempx2, pty(_(0)), tempz1
          }
          push @Binary, tempx1, pty(_(0)), tempz2
          If (sign eq "") {
            push @Binary, tempx2, pty(_(0)), tempz1
          }
          push @Binary, 0
          push @Binary, 0,sign+"1",0
          push @Binary, tempx2, pty(_(0)), tempz1
          If (sign eq "-") {
            push @Binary, tempx2, pty(_(0)), tempz2
          }
          push @Binary, tempx1, pty(_(0)), tempz2
          If (sign eq "") {
            push @Binary, tempx2, pty(_(0)), tempz2
          }
          push @Binary, 0
          polygons += 2
        }
      }
    }
  }
}

Sub planeyz {
  zz1=ptz(_(0))  zz2=ptz(_(2))  yy1=pty(_(0))  yy2=pty(_(2))
  For (i=0 i<@zpoints i++) {
    If    (zpoints(i) > zz2) { last }
    elsif (zpoints(i) == zz1) { tempz2 = zpoints(i) }
    elsif (zpoints(i) > zz1 && zpoints(i) <= zz2) {
      tempz1 = tempz2 tempz2 = zpoints(i)
      For (j=0 j<@ypoints j++) {
        If    (ypoints(j) > yy2) { last }
        elsif (ypoints(j) == yy1) { tempy2 = ypoints(j) }
        elsif (ypoints(j) > yy1 && ypoints(j) <= yy2) {
          tempy1 = tempy2 tempy2 = ypoints(j)
          push @Binary, sign+"1",0,0
          push @Binary, ptx(_(0)), tempy1, tempz1
          If (sign eq "-") {
            push @Binary, ptx(_(0)), tempy1, tempz2
          }
          push @Binary, ptx(_(0)), tempy2, tempz1
          If (sign eq "") {
            push @Binary, ptx(_(0)), tempy1, tempz2
          }
          push @Binary, 0
          push @Binary, sign+"1",0,0
          push @Binary, ptx(_(0)), tempy1, tempz2
          If (sign eq "-") {
            push @Binary, ptx(_(0)), tempy2, tempz2
          }
          push @Binary, ptx(_(0)), tempy2, tempz1
          If (sign eq "") {
            push @Binary, ptx(_(0)), tempy2, tempz2
          }
          push @Binary, 0
          polygons += 2
        }
      }
    }
  }
}


'#------- Create the STL file ----------------------
If (showstl) {

tempx1=0tempx2=0tempy1=0tempy2=0

z1=sprintf("%+3f",packagethickness)
z2=sprintf("%+3f",packagethickness+wirebondledgeheight)
z3=sprintf("%+3f",packagethickness+wirebondledgeheight+sealringheight)

x1=sprintf("%+3f",leadledgewidth)
x2=sprintf("%+3f",x1+sealringkeepout)
x3=sprintf("%+3f",x2+sealringwidth)
x4=sprintf("%+3f",x3+wirebondledgewidth)
x5=sprintf("%+3f",x4+dropinkeepout)
x11=sprintf("%+3f",px)
x10=sprintf("%+3f",x11-leadledgewidth)
x9=sprintf("%+3f",x10-sealringkeepout)
x8=sprintf("%+3f",x9-sealringwidth)
x7=sprintf("%+3f",x8-wirebondledgewidth)
x6=sprintf("%+3f",x7-dropinkeepout)

y1=sprintf("%+3f",leadledgewidth)
y2=sprintf("%+3f",y1+sealringkeepout)
y3=sprintf("%+3f",y2+sealringwidth)
y4=sprintf("%+3f",y3+wirebondledgewidth)
y5=sprintf("%+3f",y4+dropinkeepout)
y11=sprintf("%+3f",py)
y10=sprintf("%+3f",y11-leadledgewidth)
y9=sprintf("%+3f",y10-sealringkeepout)
y8=sprintf("%+3f",y9-sealringwidth)
y7=sprintf("%+3f",y8-wirebondledgewidth)
y6=sprintf("%+3f",y7-dropinkeepout)

push @xpoints, (0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11)
push @ypoints, (0,y1,y2,y3,y4,y5,y6,y7,y8,y9,y10,y11)
push @zpoints, (0,z1,z2,z3)

%seen = ()@uniq = ()
foreach Item (@xpoints) { push (@uniq, Item) unless seen{Item}++ }
@xpoints = Sort { a <=> b} @uniq
%seen = ()@uniq = ()
foreach Item (@ypoints) { push (@uniq, Item) unless seen{Item}++ }
@ypoints = Sort { a <=> b} @uniq
%seen = ()@uniq = ()
foreach Item (@zpoints) { push (@uniq, Item) unless seen{Item}++ }
@zpoints = Sort { a <=> b} @uniq

'#-creat common points For triangle - @ptx @pty @ptz
ptx(0) = 0
pty(0) = 0
ptz(0) = 0

ptx(1) = x11
pty(1) = 0
ptz(1) = 0

ptx(2) = x11
pty(2) = y11
ptz(2) = 0

ptx(3) = 0
pty(3) = y11
ptz(3) = 0

ptx(4) = 0
pty(4) = 0
ptz(4) = z1

ptx(5) = x11
pty(5) = 0
ptz(5) = z1

ptx(6) = x11
pty(6) = y11
ptz(6) = z1

ptx(7) = 0
pty(7) = y11
ptz(7) = z1

ptx(8) = x1
pty(8) = y1
ptz(8) = z1

ptx(9) = x10
pty(9) = y1
ptz(9) = z1

ptx(10) = x10
pty(10) = y10
ptz(10) = z1

ptx(11) = x1
pty(11) = y10
ptz(11) = z1

ptx(12) = x1
pty(12) = y1
ptz(12) = z2

ptx(13) = x10
pty(13) = y1
ptz(13) = z2

ptx(14) = x10
pty(14) = y10
ptz(14) = z2

ptx(15) = x1
pty(15) = y10
ptz(15) = z2

ptx(16) = x2
pty(16) = y2
ptz(16) = z2

ptx(17) = x9
pty(17) = y2
ptz(17) = z2

ptx(18) = x9
pty(18) = y9
ptz(18) = z2

ptx(19) = x2
pty(19) = y9
ptz(19) = z2

ptx(20) = x2
pty(20) = y2
ptz(20) = z3

ptx(21) = x9
pty(21) = y2
ptz(21) = z3

ptx(22) = x9
pty(22) = y9
ptz(22) = z3

ptx(23) = x2
pty(23) = y9
ptz(23) = z3

ptx(24) = x3
pty(24) = y3
ptz(24) = z3

ptx(25) = x8
pty(25) = y3
ptz(25) = z3

ptx(26) = x8
pty(26) = y8
ptz(26) = z3

ptx(27) = x3
pty(27) = y8
ptz(27) = z3

ptx(28) = x3
pty(28) = y3
ptz(28) = z2

ptx(29) = x8
pty(29) = y3
ptz(29) = z2

ptx(30) = x8
pty(30) = y8
ptz(30) = z2

ptx(31) = x3
pty(31) = y8
ptz(31) = z2

ptx(32) = x4
pty(32) = y4
ptz(32) = z2

ptx(33) = x7
pty(33) = y4
ptz(33) = z2

ptx(34) = x7
pty(34) = y7
ptz(34) = z2

ptx(35) = x4
pty(35) = y7
ptz(35) = z2

ptx(36) = x4
pty(36) = y4
ptz(36) = z1

ptx(37) = x7
pty(37) = y4
ptz(37) = z1

ptx(38) = x7
pty(38) = y7
ptz(38) = z1

ptx(39) = x4
pty(39) = y7
ptz(39) = z1

ptx(40) = x5
pty(40) = y5
ptz(40) = z1

ptx(41) = x6
pty(41) = y5
ptz(41) = z1

ptx(42) = x6
pty(42) = y6
ptz(42) = z1

ptx(43) = x5
pty(43) = y6
ptz(43) = z1

ptx(44) = x5
pty(44) = y5
ptz(44) = z2

ptx(45) = x6
pty(45) = y5
ptz(45) = z2

ptx(46) = x6
pty(46) = y6
ptz(46) = z2

ptx(47) = x5
pty(47) = y6
ptz(47) = z2

'#------- special points For HOR ----

ptx(48) = x1
pty(48) = 0
ptz(48) = z1

ptx(49) = x10
pty(49) = 0
ptz(49) = z1

ptx(50) = x10
pty(50) = y11
ptz(50) = z1

ptx(51) = x1
pty(51) = y11
ptz(51) = z1

ptx(52) = x2
pty(52) = y1
ptz(52) = z2

ptx(53) = x9
pty(53) = y1
ptz(53) = z2

ptx(54) = x9
pty(54) = y10
ptz(54) = z2

ptx(55) = x2
pty(55) = y10
ptz(55) = z2

ptx(56) = x3
pty(56) = y2
ptz(56) = z3

ptx(57) = x8
pty(57) = y2
ptz(57) = z3

ptx(58) = x8
pty(58) = y9
ptz(58) = z3

ptx(59) = x3
pty(59) = y9
ptz(59) = z3

ptx(60) = x4
pty(60) = y3
ptz(60) = z2

ptx(61) = x7
pty(61) = y3
ptz(61) = z2

ptx(62) = x7
pty(62) = y8
ptz(62) = z2

ptx(63) = x4
pty(63) = y8
ptz(63) = z2

ptx(64) = x5
pty(64) = y4
ptz(64) = z1

ptx(65) = x6
pty(65) = y4
ptz(65) = z1

ptx(66) = x6
pty(66) = y7
ptz(66) = z1

ptx(67) = x5
pty(67) = y7
ptz(67) = z1

'# XY horizontal ----
'#-package Base
sign="-"planexy 0,3,2,1
'#-package top
sign=""planexy 4,48,51,7
sign=""planexy 48,49,9,8
sign=""planexy 49,5,6,50
sign=""planexy 11,10,50,51
'#-sealring keepout (ledge outside)
sign=""planexy 12,52,55,15
sign=""planexy 52,53,17,16
sign=""planexy 53,13,14,54
sign=""planexy 19,18,54,55
'#-sealring top
sign=""planexy 20,56,59,23
sign=""planexy 56,57,25,24
sign=""planexy 57,21,22,58
sign=""planexy 27,26,58,59
If (dropin) {
  '#-ledge inside
  sign=""planexy 28,60,63,31
  sign=""planexy 60,61,33,32
  sign=""planexy 61,29,30,62
  sign=""planexy 35,34,62,63
  '#-gap
  sign=""planexy 36,64,67,39
  sign=""planexy 64,65,41,40
  sign=""planexy 65,37,38,66
  sign=""planexy 43,42,66,67 }
'#-substrate
testtriangle=1
sign=""planexy 44,45,46,47
testtriangle=0

'# XZ vertical bottom top
'#-package
sign="-"planexz 0,1,5,4
sign=""planexz 3,7,6,2
If (dropin) {
  '#-ledge outside
  sign="-"planexz 8,9,13,12
  sign=""planexz 11,15,14,10}
'#-sealring outside
sign="-"planexz 16,17,21,20
sign=""planexz 19,23,22,18
'#-sealring inside
sign=""planexz 28,24,25,29
sign="-"planexz 31,30,26,27
If (dropin) {
  '#-ledge inside
  sign=""planexz 36,32,33,37
  sign="-"planexz 39,38,34,35
  '#-substrate outside
  sign="-"planexz 40,41,45,44
  sign=""planexz 43,47,46,42  }

'# YZ vertical Left Right
'#-package
sign="-"planeyz 0,4,7,3
sign=""planeyz 1,2,6,5
If (dropin) {
  '#-ledge outside
  sign="-"planeyz 8,12,15,11
  sign=""planeyz 9,10,14,13}
'#-sealring outside
sign="-"planeyz 16,20,23,19
sign=""planeyz 17,18,22,21
'#-sealring inside
sign=""planeyz 28,31,27,24
sign="-"planeyz 29,25,26,30
If (dropin) {
  '#-ledge inside
  sign=""planeyz 36,39,35,32
  sign="-"planeyz 37,33,34,38
  '#-substrate outside
  sign="-"planeyz 40,44,47,43
  sign=""planeyz 41,42,46,45 }

If (ic0"} ne "888 888 888"){
For part (@allparts) {
  (l, w, t, k, yc, xc, ptype) = split(/::/,part)
  p0x = xc - w/2
  p0y = yc - l/2
  p0z = z
  p1x = xc + w/2
  p1y = yc - l/2
  p1z = z
  p2x = xc + w/2
  p2y = yc + l/2
  p2z = z
  p3x = xc - w/2
  p3y = yc + l/2
  p3z = z
  p4x = xc - w/2
  p4y = yc - l/2
  p4z = z  + t
  p5x = xc + w/2
  p5y = yc - l/2
  p5z = z  + t
  p6x = xc + w/2
  p6y = yc + l/2
  p6z = z  + t
  p7x = xc - w/2
  p7y = yc + l/2
  p7z = z  + t
  ptx(68) = sprintf("%+3f",p0x+packagekeepout)
  pty(68) = sprintf("%+3f",p0y+packagekeepout)
  ptz(68) = sprintf("%+3f",p0z)
  ptx(69) = sprintf("%+3f",p1x+packagekeepout)
  pty(69) = sprintf("%+3f",p1y+packagekeepout)
  ptz(69) = sprintf("%+3f",p1z)
  ptx(70) = sprintf("%+3f",p2x+packagekeepout)
  pty(70) = sprintf("%+3f",p2y+packagekeepout)
  ptz(70) = sprintf("%+3f",p2z)
  ptx(71) = sprintf("%+3f",p3x+packagekeepout)
  pty(71) = sprintf("%+3f",p3y+packagekeepout)
  ptz(71) = sprintf("%+3f",p3z)
  ptx(72) = sprintf("%+3f",p4x+packagekeepout)
  pty(72) = sprintf("%+3f",p4y+packagekeepout)
  ptz(72) = sprintf("%+3f",p4z)
  ptx(73) = sprintf("%+3f",p5x+packagekeepout)
  pty(73) = sprintf("%+3f",p5y+packagekeepout)
  ptz(73) = sprintf("%+3f",p5z)
  ptx(74) = sprintf("%+3f",p6x+packagekeepout)
  pty(74) = sprintf("%+3f",p6y+packagekeepout)
  ptz(74) = sprintf("%+3f",p6z)
  ptx(75) = sprintf("%+3f",p7x+packagekeepout)
  pty(75) = sprintf("%+3f",p7y+packagekeepout)
  ptz(75) = sprintf("%+3f",p7z)
  '#-hor top
  sign=""&planexy (72,73,74,75)
  '#-YZ vert (Left/Right)
  sign="-"&planeyz (68,72,75,71)
  sign=""&planeyz (69,73,74,70)
  '#-XZ vert (top/bottom)
  sign=""&planexz (71,70,74,75)
  sign="-"&planexz (68,69,73,72)
}
}

Open(BINOUT,"> ++/mcm/design/image"+icount+"+stl" )
'#binmode BINOUT
Print BINOUT pack("A80V","3D MCM Image", polygons)
For (i=0 i<#binary i+=13) {
'#  Print BINOUT pack("f12S",@Binary(i ++ i+12))
  temp = reverse pack("f",Binary(i))    Print BINOUT temp
  temp = reverse pack("f",Binary(i+1))  Print BINOUT temp
  temp = reverse pack("f",Binary(i+2))  Print BINOUT temp
  temp = reverse pack("f",Binary(i+3))  Print BINOUT temp
  temp = reverse pack("f",Binary(i+4))  Print BINOUT temp
  temp = reverse pack("f",Binary(i+5))  Print BINOUT temp
  temp = reverse pack("f",Binary(i+6))  Print BINOUT temp
  temp = reverse pack("f",Binary(i+7))  Print BINOUT temp
  temp = reverse pack("f",Binary(i+8))  Print BINOUT temp
  temp = reverse pack("f",Binary(i+9))  Print BINOUT temp
  temp = reverse pack("f",Binary(i+10)) Print BINOUT temp
  temp = reverse pack("f",Binary(i+11)) Print BINOUT temp
  Print BINOUT    pack("S",Binary(i+12))
}
Close (BINOUT)

Print Out "<p>\nThe STL file consists of polygons triangles - derived from "
+scalar(@xpoints)+" x-points, "+scalar(@ypoints)+
" y-points and "+scalar(@zpoints)+" z-points+"
}

If (measure) { timerresult20 = tv_interval ( t0 )}

If (measure) {
Print Out "<br> @xpoints"
Print Out "<br>\n"
Print Out "@ypoints"
Print Out "<br>\n"
Print Out "@zpoints"
Print Out "<br>\n"

Print Out "\n <table>"
Print Out "\n <tr><td>components:  <td>timerresult1<br>"
Print Out "\n <tr><td>area/power:  <td>timerresult2<br>"
Print Out "\n <tr><td>placement:   <td>timerresult3<br>"
Print Out "\n <tr><td>parts:       <td>timerresult4<br>"
Print Out "\n <tr><td>pkg size:    <td>timerresult5<br>"
Print Out "\n <tr><td>I/O calc:    <td>timerresult6<br>"
Print Out "\n <tr><td>package:     <td>timerresult7<br>"
Print Out "\n <tr><td>substrate: <td>timerresult8<br>"
Print Out "\n <tr><td>interconnect: <td>timerresult9<br>"
Print Out "\n <tr><td>sealring: <td>timerresult10<br>"
Print Out "\n <tr><td>lid: <td>timerresult11<br>"
Print Out "\n <tr><td>wirebondledge: <td>timerresult12<br>"
Print Out "\n <tr><td>solder balls: <td>timerresult13<br>"
Print Out "\n <tr><td>wirebonds: <td>timerresult14<br>"
Print Out "\n <tr><td>leads: <td>timerresult15<br>"
Print Out "\n <tr><td>pads: <td>timerresult16<br>"
Print Out "\n <tr><td>imageXX+txt: <td>timerresult17<br>"
Print Out "\n <tr><td>imageXX+htm: <td>timerresult18<br>"
Print Out "\n <tr><td>STL: <td>timerresult19<br>"
Print Out "\n <tr><td>end: <td>timerresult20<br>"
Print Out "\n </table>"
}

Print Out <<stop_html44
    </ul>
</table>
</body>
</html>
stop_html44

Close Out

'#------- Send To the newly created image+htm ----------------------
chmod 0755 , "++/mcm/design/image"+icount+"+txt"
chmod 0755 , "++/mcm/design/image"+icount+"+htm"
Print "Location: http://www+garybeene+com/mcm/design/image"+icount+"+htm\n\n"
'#print "Location: http://127+0+0+1/mcm/design/image"+icount+"+htm\n\n"
